
//+------------------------------------------------------------------
//| %r ma cross histo
//+------------------------------------------------------------------
//
//

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Lime
#property indicator_color2     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_maximum    1
#property indicator_minimum    0


//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern int             WprPeriod       = 14;
extern int             MaPeriod        = 34;
extern ENUM_MA_METHOD  MaMode          = MODE_LWMA;
extern bool            alertsOn        = false;
extern bool            alertsOnCurrent = true;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = true;
extern bool            alertsEmail     = true;
extern string          soundFile       = "alert2.wav"; 

//
//
//
//
//

double Up[];
double Dn[];
double wpr[];
double wprma[];
double trend[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
    IndicatorBuffers(5);
    SetIndexBuffer(0,Up); SetIndexStyle(0,DRAW_HISTOGRAM);
    SetIndexBuffer(1,Dn); SetIndexStyle(1,DRAW_HISTOGRAM);
    SetIndexBuffer(2,wpr);
    SetIndexBuffer(3,wprma);
    SetIndexBuffer(4,trend);
    
    //
    //
    //
    //
    //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == -99);
      TimeFrame         = MathMax(TimeFrame,_Period);   
   IndicatorShortName(timeFrameToString(TimeFrame)+"  %R  (" +WprPeriod+ ", " +MaPeriod+ ")");
 return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Up[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         double hi   = High[iHighest(NULL,0, MODE_HIGH,WprPeriod,i)];
         double lo   =  Low[iLowest(NULL, 0,  MODE_LOW,WprPeriod,i)];
         if (hi!=lo)      
              wpr[i] = -100*(hi-Close[i]) / (hi-lo);
         else wpr[i] = 0;  
      }
      for (i = limit; i >= 0 ; i--) 
      {
         wprma[i] = iMAOnArray(wpr,0,MaPeriod,0,MaMode,i);
         Up[i]    = EMPTY_VALUE;
         Dn[i]    = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (wpr[i]>wprma[i]) trend[i] = 1;
            if (wpr[i]<wprma[i]) trend[i] =-1;
            if (trend[i] == 1)   Up[i]    = 1;
            if (trend[i] ==-1)   Dn[i]    = 1;
      }      
      manageAlerts();
    return(0);
    }
    
    //
    //
    //
    //
    //       
    
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
          Up[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,WprPeriod,MaPeriod,MaMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
          Dn[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,WprPeriod,MaPeriod,MaMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
   } 
   return(0);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"Buy");
         if (trend[whichBar] == -1) doAlert(whichBar,"Sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," wpr ma cross ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," wpr ma cross " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," wpr ma cross "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


